## ratpoints 2.1.3

=== Makefile ===
#   ratpoints-2.1.3
#    - A program to find rational points on hyperelliptic curves
#   Copyright (C) 2008, 2009  Michael Stoll
#
#   This program is free software: you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   as published by the Free Software Foundation, either version 2 of
#   the License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of version 2 of the GNU General
#   Public License along with this program.
#   If not, see <http://www.gnu.org/licenses/>.
#
#
#    Makefile
#
#    Michael Stoll, September 21, 2009

PRIME_SIZE = 7

CC = gcc
RM = rm -f
INSTALL = cp

INSTALL_DIR = /usr/local

CCFLAGS1 = -Wall -O2 -fomit-frame-pointer -DRATPOINTS_MAX_BITS_IN_PRIME=${PRIME_SIZE} -DUSE_SSE
# for gcc on Apple, may have to add '-fnested-functions' to CCFLAGS1
CCFLAGS2 = -lgmp -lgcc -lc -lm
CCFLAGS3 = -L. -lratpoints
CCFLAGS = 


DISTFILES = Makefile ratpoints.h rp-private.h primes.h \
            gen_find_points_h.c gen_init_sieve_h.c \
            sift.c init.c sturm.c find_points.c \
            main.c rptest.c testdata.h testbase ratpoints-doc.pdf \
            gpl-2.0.txt

TEMPFILES = sift.o init.o sturm.o find_points.o \
            sift.s init.s find_points.h init_sieve.h \
            gen_find_points_h gen_init_sieve_h \
            rptest.out sift-debug.o find_points-debug.o main.o

TARGETFILES = ratpoints libratpoints.a rptest ratpoints-debug

all: ratpoints libratpoints.a

test: rptest testbase
	time ./rptest > rptest.out
#	diff -q testbase rptest.out
	cmp -s testbase rptest.out || echo "Test failed!"

install-bin: ratpoints
	${INSTALL} ratpoints ${INSTALL_DIR}/bin/
	chmod 755 ${INSTALL_DIR}/bin/ratpoints

install-lib: ratpoints.h libratpoints.a
	${INSTALL} ratpoints.h ${INSTALL_DIR}/include/
	chmod 644 ${INSTALL_DIR}/include/ratpoints.h
	${INSTALL} libratpoints.a ${INSTALL_DIR}/lib/
	chmod 644 ${INSTALL_DIR}/lib/libratpoints.a

install: install-bin install-lib

dist: ${DISTFILES}
	mkdir -p ratpoints-2.1.3
	cp ${DISTFILES} ratpoints-2.1.3/
	tar --create --file=ratpoints-2.1.3-`date --rfc-3339=date`.tar.gz \
	    --gzip --dereference ratpoints-2.1.3
	rm -r ratpoints-2.1.3

clean: 
	${RM} ${TEMPFILES}

distclean: clean
	${RM} ${TARGETFILES}

debug: ratpoints-debug

libratpoints.a: sift.o init.o sturm.o find_points.o
	ar rs libratpoints.a sift.o init.o sturm.o find_points.o

ratpoints: libratpoints.a main.c ratpoints.h
	${CC} main.c -o ratpoints ${CCFLAGS1} ${CCFLAGS2} ${CCFLAGS3} ${CCFLAGS}

main.o: main.c ratpoints.h
	${CC} main.c -c -o main.o ${CCFLAGS1} -O3 ${CCFLAGS}

ratpoints-debug: sift-debug.o init.o sturm.o find_points-debug.o main.o
	${CC} sift-debug.o init.o sturm.o find_points-debug.o main.o \
              -o ratpoints-debug ${CCFLAGS1} ${CCFLAGS2} ${CCFLAGS}

sift.o: sift.c ratpoints.h rp-private.h
	${CC} sift.c -c -o sift.o ${CCFLAGS1} -funroll-loops ${CCFLAGS}

sift-debug.o: sift.c ratpoints.h rp-private.h
	${CC} sift.c -c -o sift-debug.o ${CCFLAGS1} -funroll-loops -DDEBUG ${CCFLAGS}

sift.s: sift.c ratpoints.h rp-private.h
	${CC} sift.c -S -o sift.s ${CCFLAGS1} -funroll-loops ${CCFLAGS}

sift.i: sift.c ratpoints.h rp-private.h
	${CC} sift.c -E -o sift.i ${CCFLAGS1} -funroll-loops ${CCFLAGS}

init.o: init.c ratpoints.h rp-private.h init_sieve.h
	${CC} init.c -c -o init.o ${CCFLAGS1} -funroll-loops -O3 ${CCFLAGS}

init.s: init.c ratpoints.h rp-private.h init_sieve.h
	${CC} init.c -S -o init.s ${CCFLAGS1} -funroll-loops -O3 ${CCFLAGS}

sturm.o: sturm.c ratpoints.h rp-private.h
	${CC} sturm.c -c -o sturm.o ${CCFLAGS1} ${CCFLAGS}

find_points.o: find_points.c ratpoints.h rp-private.h primes.h find_points.h
	${CC} find_points.c -c -o find_points.o ${CCFLAGS1} ${CCFLAGS}

find_points-debug.o: find_points.c ratpoints.h rp-private.h primes.h find_points.h
	${CC} find_points.c -c -o find_points-debug.o ${CCFLAGS1} -DDEBUG ${CCFLAGS}

rptest: libratpoints.a rptest.c ratpoints.h testdata.h
	${CC} rptest.c -o rptest ${CCFLAGS1} ${CCFLAGS2} ${CCFLAGS3} ${CCFLAGS}

gen_init_sieve_h: gen_init_sieve_h.c ratpoints.h rp-private.h primes.h
	${CC} gen_init_sieve_h.c -o gen_init_sieve_h  ${CCFLAGS1} ${CCFLAGS2} ${CCFLAGS}

gen_find_points_h: gen_find_points_h.c ratpoints.h rp-private.h primes.h
	${CC} gen_find_points_h.c -o gen_find_points_h  ${CCFLAGS1} ${CCFLAGS2} ${CCFLAGS}

init_sieve.h: gen_init_sieve_h
	./gen_init_sieve_h > init_sieve.h

find_points.h: gen_find_points_h
	./gen_find_points_h > find_points.h

=== debian/changelog ===
ratpoints (1:2.1.3-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Point Vcs fields to salsa.debian.org (routine-update)
  * Secure URI in copyright format (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Apply multi-arch hints.
    + libratpoints-dev: Add Multi-Arch: same.
  * watch file standard 4 (routine-update)
  * enable dh_missing --fail-missing

 -- Andreas Tille <tille@debian.org>  Sat, 13 Nov 2021 18:41:09 +0100

ratpoints (1:2.1.3-1) unstable; urgency=medium

  * New package ratpoints containing the ratpoints binary and the
    documentation ratpoints-doc.pdf. (Closes: #745810)
  * Include source of ratpoints-doc.pdf in debian/missing-sources/.
  * Remove repack infrastructure.
  * Include change from Ubuntu (2.1.3+dfsg-2ubuntu1) to resolve
    FTBFS from linking order. Thanks Daniel T Chen. (Closes: #729506)
  * Abort package build when test fails.
  * Bump Standards-Version to 3.9.5.

 -- Tobias Hansen <thansen@debian.org>  Wed, 09 Jul 2014 21:24:14 +0200

ratpoints (2.1.3+dfsg-2) unstable; urgency=low

  * Fix build with changed location of gmp header. (Closes: #717533)
  * Don't ship a copy of the GPL.
  * Remove unused lintian override.
  * Make Vcs-* fields canonical.

 -- Tobias Hansen <thansen@debian.org>  Mon, 29 Jul 2013 00:33:00 +0200

ratpoints (2.1.3+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #700184)

 -- Tobias Hansen <thansen@debian.org>  Wed, 05 Jun 2013 20:48:43 +0200

=== debian/control ===
Source: ratpoints
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libgmp-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/ratpoints
Vcs-Git: https://salsa.debian.org/science-team/ratpoints.git
Homepage: https://www.mathe2.uni-bayreuth.de/stoll/programs/
Rules-Requires-Root: no

Package: ratpoints
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: find rational points on hyperelliptic curves
 This program tries to find all rational points within a given height
 bound on a hyperelliptic curve in a very efficient way, by using
 an optimized quadratic sieve algorithm.

Package: libratpoints-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libratpoints-2.1.3 (= ${binary:Version})
Multi-Arch: same
Description: development files for libratpoints
 This program tries to find all rational points within a given height
 bound on a hyperelliptic curve in a very efficient way, by using
 an optimized quadratic sieve algorithm.
 .
 This package contains the development files for the library.

Package: libratpoints-2.1.3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for finding rational points on hyperelliptic curves
 This program tries to find all rational points within a given height
 bound on a hyperelliptic curve in a very efficient way, by using
 an optimized quadratic sieve algorithm.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_autoreconf:
	touch NEWS README AUTHORS ChangeLog
	dh_autoreconf
	rm -f NEWS README AUTHORS ChangeLog

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules --with-gmp-headers=/usr/include/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
http://www.mathe2.uni-bayreuth.de/stoll/programs/ratpoints-(.*)\.tar\.gz

## ratpoints 2.1.3%2Bdfsg

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg$// \
    http://www.mathe2.uni-bayreuth.de/stoll/programs/ratpoints-(.*)\.tar\.gz \
    debian sh debian/repack.stub

## ratpoints 2.1.3+dfsg

=== debian/changelog ===
ratpoints (2.1.3+dfsg-2ubuntu1) trusty; urgency=low

  * Resolved FTBFS from linking order.

 -- Daniel T Chen <crimsun@ubuntu.com>  Wed, 13 Nov 2013 11:29:04 -0500

=== debian/control ===
Source: ratpoints
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf (>= 4~), libgmp-dev
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.mathe2.uni-bayreuth.de/stoll/programs/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ratpoints.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ratpoints.git;a=summary

Package: libratpoints-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libratpoints-2.1.3 (= ${binary:Version})
Description: development files for libratpoints
 This program tries to find all rational points within a given height
 bound on a hyperelliptic curve in a very efficient way, by using
 an optimized quadratic sieve algorithm.
 .
 This package contains the development files for the library.

Package: libratpoints-2.1.3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for finding rational points on hyperelliptic curves
 This program tries to find all rational points within a given height
 bound on a hyperelliptic curve in a very efficient way, by using
 an optimized quadratic sieve algorithm.
